using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;

namespace SyncfusionGridCombo
{
    public partial class Form1 : Form
    {
        DataTable dt;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load( object sender, EventArgs e )
        {
            // load dummy data in a datatable
            dt = new DataTable();
            dt.Columns.Add( "A" );
            dt.Columns.Add( "B" );

            for ( int i = 0; i < 200000; i++ )
                dt.Rows.Add( new object[] { "A" + i.ToString(), "B" + i.ToString() }  );

            // make the upper left cell of the grid a combo
            gridControl1[1, 1].BaseStyle = "Combo";
            
            gridControl1.CurrentCellShowingDropDown+=new GridCurrentCellShowingDropDownEventHandler(gridControl1_CurrentCellShowingDropDown);
        }

        private void gridControl1_CurrentCellActivated( object sender, EventArgs e )
        {
            // a dummy data table to bind to the combo or else the combo won't even drop down
            DataTable dt = new DataTable();
            dt.Columns.Add( "A" );
            dt.Columns.Add( "B" );
            //dt.Rows.Add( new object[] { "A", "B" } );
            gridControl1[1, 1].DataSource = dt;

            // get at the embedded GridListControl and attach some events to handle its data in virtual mode
            GridCurrentCell cc = gridControl1.CurrentCell;
            if ( cc.Renderer.GetType() == typeof( GridDropDownGridListControlCellRenderer ) )
            {
                GridDropDownGridListControlCellRenderer cr = cc.Renderer as GridDropDownGridListControlCellRenderer;
                cr.ListControlPart.Grid.QueryRowCount += new GridRowColCountEventHandler( Grid_QueryRowCount );
                cr.ListControlPart.Grid.QueryColCount += new GridRowColCountEventHandler( Grid_QueryColCount );
                cr.ListControlPart.Grid.QueryCellInfo += new GridQueryCellInfoEventHandler( Grid_QueryCellInfo );

                cr.ListControlPart.AutoSizeColumns = true;
                //cr.ListControlPart.DropDownRows = 10;
                cr.ListControlPart.Grid.RowCount = 10;
                cr.ListControlPart.Height = 150;
            }
        }

        private void gridControl1_CurrentCellCloseDropDown( object sender, Syncfusion.Windows.Forms.PopupClosedEventArgs e )
        {
            // when the combo closes up, try to get the selected item and copy it into the grid cell (DOES NOT WORK)
            if ( e.PopupCloseType == PopupCloseType.Done )
            {
                GridCurrentCell cc = gridControl1.CurrentCell;
                if ( cc.Renderer.GetType() == typeof( GridDropDownGridListControlCellRenderer ) )
                {
                    GridDropDownGridListControlCellRenderer cr = cc.Renderer as GridDropDownGridListControlCellRenderer;

                    object v = cr.ListControlPart.Grid[cr.ListControlPart.Grid.CurrentCell.RowIndex,1].CellValue;

                    gridControl1[gridControl1.CurrentCell.RowIndex, gridControl1.CurrentCell.ColIndex].CellValue = v;
                }
            }
        }

        private void gridControl1_CurrentCellShowingDropDown( object sender, GridCurrentCellShowingDropDownEventArgs e ) 
        {
        }

        void Grid_QueryCellInfo( object sender, GridQueryCellInfoEventArgs e )
        {
            if ( e.RowIndex > 0 && e.ColIndex > 0 )
            {
                e.Style.CellValue = dt.Rows[e.RowIndex - 1][e.ColIndex - 1];
                e.Handled = true;
            }
        }

        void Grid_QueryColCount( object sender, GridRowColCountEventArgs e )
        {
            e.Count = dt.Columns.Count;
            e.Handled = true;
        }

        void Grid_QueryRowCount( object sender, GridRowColCountEventArgs e )
        {
            e.Count = dt.Rows.Count;
            e.Handled = true;
        }
    }
}